﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace SilverlightApplication1
{
    public class DataItem : INotifyPropertyChanged, IPath
    {
        private bool isSelected;

        public DataItem()
        {
            this.Children = new ObservableCollection<DataItem>();
            this.Children.CollectionChanged += new System.Collections.Specialized.NotifyCollectionChangedEventHandler(Children_CollectionChanged);
        }

        void Children_CollectionChanged(object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e)
        {
            if (e.Action == System.Collections.Specialized.NotifyCollectionChangedAction.Add)
            {
                var item = e.NewItems[0] as IPath;
                item.Parent = this;
            }
        }

        public string Title { get; set; }
        public ObservableCollection<DataItem> Children { get; set; }
        public bool IsSelected
        {
            get
            {
                return this.isSelected;
            }
            set
            {
                if (this.isSelected != value)
                {
                    this.isSelected = value;
                    this.OnPropertyChanged("IsSelected");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChanged(string propertyName)
        {
            if (this.PropertyChanged != null)
            {
                this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        public override string ToString()
        {
            return this.Title;
        }

        public IPath Parent
        {
            get;
            set;
        }

        public string GetFullPath()
        {
            if (this.Parent != null)
            {
                return this.Parent.GetFullPath() + "|" + this.ToString();
            }
            return this.ToString();
        }
    }
}
