﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;
using Telerik.Windows.Controls;
using System.Collections;
using System.Diagnostics;

namespace SilverlightApplication1
{
    public partial class MainPage : UserControl
    {
        DataItem selectedItem = new DataItem();

        public MainPage()
        {
            InitializeComponent();

            ObservableCollection<DataItem> dataItems = new ObservableCollection<DataItem>();
            for (int i = 0; i < 1000; i++)
            {
                DataItem d1 = new DataItem() { Title = string.Format("Item {0}", i) };

                for (int j = 0; j < 5; j++)
                {
                    DataItem d2 = new DataItem() { Title = string.Format("Sub-Item {0}", j)};
                    for (int k = 0; k < 5; k++)
                    {
                         DataItem d3 = new DataItem() { Title = string.Format("Sub-Sub-Item {0}", k), IsSelected = (i == 1 && j == 2 && k==3) };
                         d2.Children.Add(d3);
                    }
                    d1.Children.Add(d2);
                }
                dataItems.Add(d1);
            }

            this.treeView1.ItemsSource = dataItems;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            GetSelectedItem(treeView1.ItemsSource as IList);
            treeView1.ExpandItemByPath(selectedItem.GetFullPath(), "|");

        }

        private void GetSelectedItem(IList ItemsCollection)
        {
            foreach (DataItem item in ItemsCollection)
            {
                if (item.IsSelected)
                    selectedItem = item;
                else
                    GetSelectedItem(item.Children);
            }
        }

        private void buttonExpandByPath_Click(object sender, RoutedEventArgs e)
        {
            string path = PathBox.Text;
            RadTreeViewItem toSelect =  treeView1.GetItemByPath(path, "|" ) ;
            if (toSelect != null)
            {
                toSelect.IsSelected = true;
            }
        }

        private void CollapseAll(object sender, RoutedEventArgs e)
        {
            this.treeView1.CollapseAll();
        }

    }

   
}
